=== cmake/make_dist/CMakeLists.txt ===
# Copyright 2018-present MongoDB Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set (cmake_make_dist_MODULES
   MakeDist.cmake
   MakeDistCheck.cmake
   MakeDistFiles.cmake
)

set_dist_list (cmake_make_dist_DIST
   CMakeLists.txt
   COPYING-CMAKE-SCRIPTS.txt
   ${cmake_make_dist_MODULES}
)
