=== examples/bsoncxx/CMakeLists.txt ===
# Copyright 2016 MongoDB Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

include_directories(
    ${CMAKE_INSTALL_PREFIX}/${BSONCXX_HEADER_INSTALL_DIR}
)

set(BSONCXX_EXAMPLES
    builder_core.cpp
    builder_basic.cpp
    builder_stream.cpp
    builder_stream_customization.cpp
    decimal128.cpp
    getting_values.cpp
    view_and_value.cpp
)

foreach(EXAMPLE_SRC ${BSONCXX_EXAMPLES})
    get_filename_component(EXAMPLE_TARGET ${EXAMPLE_SRC} NAME_WE)
    add_executable(${EXAMPLE_TARGET} ${EXAMPLE_SRC})
    target_link_libraries(${EXAMPLE_TARGET} ${BSONCXX_LIBRARY_FOR_EXAMPLES})
    set(BSONCXX_EXAMPLE_EXECUTABLES ${BSONCXX_EXAMPLE_EXECUTABLES} ${EXAMPLE_TARGET})
endforeach(EXAMPLE_SRC)

set(BSONCXX_EXAMPLE_EXECUTABLES ${BSONCXX_EXAMPLE_EXECUTABLES} PARENT_SCOPE)

set_dist_list (examples_bsoncxx_DIST
   CMakeLists.txt
   ${BSONCXX_EXAMPLES}
)
