=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
include /usr/share/dpkg/pkg-info.mk

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND := -lpthread

# main packaging script based on dh7 syntax
%:
	dh $@

override_dh_auto_configure:
ifneq (,$(filter pkg.mongo-cxx-driver.mnmlstc,$(DEB_BUILD_PROFILES)))
	dh_auto_configure -B$(CURDIR)/build -- \
	-DBUILD_VERSION=$(DEB_VERSION_UPSTREAM) \
	-DBSONCXX_POLY_USE_MNMLSTC=1 \
	-DENABLE_UNINSTALL=OFF
else
	dh_auto_configure -B$(CURDIR)/build -- \
	-DBUILD_VERSION=$(DEB_VERSION_UPSTREAM) \
	-DBSONCXX_POLY_USE_BOOST=1 \
	-DENABLE_UNINSTALL=OFF
endif

override_dh_auto_build:
ifneq (,$(filter pkg.mongo-cxx-driver.mnmlstc,$(DEB_BUILD_PROFILES)))
	dh_auto_build -B$(CURDIR)/build -- all doxygen-current DESTDIR=$(CURDIR)/debian/tmp-mnmlstc
else
	dh_auto_build -B$(CURDIR)/build -- all doxygen-current
endif

override_dh_auto_install:
	dh_auto_install -B$(CURDIR)/build
	find $(CURDIR)/debian/tmp -type d -empty -delete
	rm -f $(CURDIR)/debian/tmp/usr/share/mongo-cxx-driver/LICENSE
ifneq (,$(filter pkg.mongo-cxx-driver.mnmlstc,$(DEB_BUILD_PROFILES)))
	# Drop MNMLSTC headers in a location where dh_install will pick them up
	mv $(CURDIR)/debian/tmp-mnmlstc/usr/include/bsoncxx/v_noabi/bsoncxx/third_party \
	   $(CURDIR)/debian/tmp/usr/include/bsoncxx/v_noabi/bsoncxx/
	rm -rf $(CURDIR)/debian/tmp-mnmlstc
	# Fix MNMLSTC headers; handle the CMake external project step patched out
	# by debian/patches/0002_skip_mnmlstc_extra_step.patch
	( cd $(CURDIR)/debian/tmp/usr/include/bsoncxx/v_noabi/bsoncxx/third_party/mnmlstc; \
	   find . -type f | xargs perl -pi -e "s|#include <core|#include <bsoncxx/third_party/mnmlstc/core|g" )
endif

override_dh_auto_test:
	# do nothing

override_dh_missing:
	dh_missing --fail-missing
